#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Apr  5 16:26:51 2021

@author: anton
"""

from SLiCAP import *
prj = initProject('OpAmp data')
htmlPage('Summary OpAmp requirements')
head2html('Voltage drive capability')
txt = """With an RMS load voltage of 0dBm (225mV) the RMS output voltage of the
OpAmp will be 450mV. Assuming a crest factor of 3, the peak-to-peak output
voltage will be 2.7V. If we assume a sinusoidal output, the peak-to-peak drive
capability must be 1.3V. If we assume a full-power bandwidth equal to the small-
signal bandwidth, the voltage slew rate should be: $2\\pi f_\\max \\sqrt{2}
\\times 0.45=120V/\\mu$s."""
text2html(txt)
head2html('Current drive capability')
txt = """With a crest factor of 3, the amplifier needs to drive $\\pm 13.5$mA.
If we assu,e a sinusoidal output signal, the peak-peak current drive capability 
should be 13mA."""
text2html(txt)
head2html('DC gain')
txt = """The DC gain sets the midband accuracy. For an inaccuracy smaller than
20%, we require a DC gain of 15."""
text2html(txt)
head2html('GB product')
txt = """If we assume a single-pole, zero output impedance and zero input 
capacitance OpAmp, the GB product must equal the ratio of the required 
bandwidth and the gain of the feedback network. This amounts 90MHz."""
text2html(txt)
head2html('Input capacitance')
txt = """If the input capacitance of the OpAmp is much smaller than the antenna
capacitance, the GB product needs to be larger than the above minimum."""
text2html(txt)
head2html('Output resistance')
txt = """The output impedance of the opamp causes attenuation of the loop gain.
As a result, the requirement for the GB product increases. The pole caused by the
parallel connection of the load impedance, the output impedance and the feedback
capacitance in series with the antenna capacitance, however, will not become dominant."""
text2html(txt)
head2html('Equivalent-input voltage noise')
txt = """If we assume white noise, then the spectrum of the input voltage noise
should be less than $L_A\\frac{C_A}{C_f+C_A}S_{EA}$, where $S_{EA}$ is the 
antenna referred noise in $\\frac{V}{m\\sqrt{Hz}}$, $L_A$ is the antenna length,
$C_A$ the antenna capacitance and $C_f$ the feedback capacitance. This equals
3.3 $\\frac{nV}{\\sqrt{Hz}}$."""
text2html(txt)
head2html('Equivalent-input current noise')
txt = """If we assume white noise, then the spectrum of the input current noise
should contribute less than 200nV/rt(Hz) to the antenna-referred spectrum at a
frequency of 10kHz. From this is follows that the spectral density of the current 
noise should be less than $S_{EA_{f\\ell}}L_A2\\pi f_{\\ell}C_A= 40\\frac{fA}{\\sqrt{Hz}}$.
Where $S_{EA_{f\\ell}}$ is the antenna-referred noise at the lowest frequency of interest."""
text2html(txt)
head2html('Input bias and offset current')
txt = """See section about biasing. Bias current up to about 5nA (noise limited)."""
text2html(txt)
head2html('Common-mode input voltage range and offset voltage')
txt = """The input of the OpAmp is biased at half the power supply. The 
offset voltage and bias current do not cause a noticeable change in the load
drive capability (See section about biasing)."""
text2html(txt)